#include <os.h>
#include "textbuffer.h"

int textbuffer_resize(textbuffer_t* tb, int newcap){
	char* tmp;
	if((tmp = realloc(tb->text, newcap)) == NULL){
		printf("textbuffer_resize: realloc failed\n");
		return 1;
	}
	else{
		tb->text = tmp;
		tb->capacity = newcap;
		return 0;
	}
}

int textbuffer_insertstr(textbuffer_t* tb, char* str, int pos){
	//check capacity of tb
	if(tb->capacity < tb->size + strlen(str)){
		if(textbuffer_resize(tb, tb->capacity + 1024) != 0)
			return 1;
	}
	//move the old str from pos and insert the new one
	memmove(tb->text + pos + strlen(str), tb->text + pos
}
