#ifndef _TEXTBUFFER_H_
#define _TEXTBUFFER_H_

typedef struct{
	char* text;//not '\0'-terminated!
	int size;
	int capacity;
}textbuffer_t;

void textbuffer_insertc(textbuffer_t* tb, char c, int pos);

void textbuffer_insertstr(textbuffer_t* tb, char* str, int pos);

void textbuffer_erasec(textbuffer_t* tb, int pos);

void textbuffer_erasestr(textbuffer_t* tb, int first, int last);//erases range [first, last)

#endif
